-- przyklad z ksiki Kalen Delaney, MS SQL Server 2000
USE tempdb;

alter database tempdb set recursive_triggers on
go

drop table if exists budzet;
go
create table budzet
(
  nazwa_wydzialu varchar(30) not null,
  nazwa_wydzialu_nadrzednego varchar(30) null,
  budzet_miesieczny int not null
)
go

delete from budzet
insert budzet values( 'Szkolenia krajowe', 'Szkolenia', 10 )
insert budzet values( 'Szkolenia', 'Usugi edukacyjne', 100 )
insert budzet values( 'Usugi edukacyjne', 'Usugi', 500 )
insert budzet values( 'Usugi', null, 1200 )
go

drop trigger if exists update_budzet
go
create trigger update_budzet on budzet after update as
begin
  declare @rows int
  set @rows=@@rowcount
  if ( @rows=0 ) return
  if ( @rows>1 ) begin
    print 'Mona modyfikowa tylko jeden wiersz jednoczenie'
    rollback transaction
    return
  end
  if ( ( select nazwa_wydzialu_nadrzednego from inserted ) is null ) return
  update budzet set budzet_miesieczny=budzet_miesieczny +
    ( select budzet_miesieczny from inserted ) -
    ( select budzet_miesieczny from deleted )
    where nazwa_wydzialu=( select nazwa_wydzialu_nadrzednego from deleted )
end
go

select * from budzet

update budzet set budzet_miesieczny=20 where nazwa_wydzialu='Szkolenia krajowe'

select * from budzet
